module CustomFielder
  class ActionView::Helpers::FormBuilder
    include ActionView::Helpers::TagHelper
    include ActionView::Helpers::FormTagHelper
    include ActionView::Helpers::FormOptionsHelper
    include ActionView::Helpers::CaptureHelper
    include ActionView::Helpers::AssetTagHelper

    ##
    # form_for method for generating all fields and labels for a users
    # custom fields to be edited
    #
    # @return [String] HTML
    #
    def custom_fields
      fields_for :custom_fielder_values do |f|
        cf = f.object

        field = [f.label(:value, cf.field.name)]
        field << begin
          unless cf.field.options.nil?
            f.select :value, cf.field.options.inject(Hash.new) { |h, v| h[v] = v; h }
          else
            case cf.field.field_type
            when 'String', 'Integer', 'Float'
              f.text_field :value
            when 'Date'
              f.date_field :value
            when 'DateTime'
              f.datetime_field :value
            when 'Boolean'
              f.select :value, { 'True' => true, 'False' => false }
            end
          end
        end

        safe_join(field)
      end
    end

    private

    delegate :safe_join, :content_tag, to: :@template
  end
end
